/*
 * Code for class PROCESS_UNIX_OS
 */

#include "eif_eiffel.h"
#include "../E1/estructure.h"
#include "../E1/eoffsets.h"

#include "pr541.h"
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include "eif_process.h"
#include <unistd.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INLINE_F603_8886
static void inline_F603_8886 (EIF_INTEGER_32 arg1, EIF_INTEGER_32 arg2)
{
	{
  int rc;
  rc = dup2(arg1, arg2);
  if (rc < 0) {
	    eraise(Strerror(errno), EN_SYS);
  }
}
	;
}
#define INLINE_F603_8886
#endif
#ifndef INLINE_F603_8887
static void inline_F603_8887 (EIF_INTEGER_32 arg1)
{
	{
	 int rc;
	  rc = close(arg1);
	  if (rc != 0) {
	    eraise(Strerror(errno), EN_SYS);
	  }
}
	;
}
#define INLINE_F603_8887
#endif
#ifndef INLINE_F603_8901
static void inline_F603_8901 (EIF_INTEGER_32* arg1)
{
	{
  pid_t pid;
  pid = fork();
  *arg1 = (EIF_INTEGER)pid;
}
	;
}
#define INLINE_F603_8901
#endif
#ifndef INLINE_F603_8890
static void inline_F603_8890 (void)
{
	{
	setpgid (0, 0);
}
	;
}
#define INLINE_F603_8890
#endif
#ifndef INLINE_F603_8903
static void inline_F603_8903 (EIF_INTEGER_32 arg1, EIF_POINTER* arg2)
{
	{
	EIF_POINTER result;
	result = (EIF_POINTER) malloc((size_t) (arg1 * sizeof(char *)));
	if (result == NULL) {
		enomem();
	}
	*arg2 = result;
}
	;
}
#define INLINE_F603_8903
#endif
#ifndef INLINE_F603_8897
static void inline_F603_8897 (EIF_POINTER arg1, EIF_POINTER* arg2)
{
	{
	  char *result;
	  result = (char *) malloc((unsigned) (strlen((char *) arg1) + 1));
	  if (result == NULL) {
    	enomem();
	  }
	  strcpy(result, arg1);
	  *arg2 = result;
	}
	;
}
#define INLINE_F603_8897
#endif
#ifndef INLINE_F603_8904
static void inline_F603_8904 (EIF_POINTER arg1, EIF_INTEGER_32 arg2, EIF_POINTER arg3)
{
	{
				  char ** arguments;
 				  arguments = (char **) arg1;
				  arguments[arg2] = (char *) arg3;
				}
	;
}
#define INLINE_F603_8904
#endif
#ifndef INLINE_F603_8902
static void inline_F603_8902 (EIF_POINTER arg1, EIF_POINTER arg2, EIF_POINTER arg3, EIF_BOOLEAN arg4)
{
	{
				  int max_descriptors;
				  int k, rc;
  				  if (arg4 == EIF_TRUE) {
				    max_descriptors = getdtablesize();
					for (k = 3; k < max_descriptors; k++) {
					    rc = fcntl(k, F_SETFD, 1);
					    if (rc == -1 && errno != EBADF) {
						      eraise(Strerror(errno), EN_SYS);
					    }
			  	    }
				  }
				  if (arg3 == NULL) {
				    (void) execv((char *) arg1, (char **) arg2);
				  } else {
				    (void) execve((char *) arg1, (char **) arg2, (char **) arg3);
				  }
				  _exit(127);
				}
	;
}
#define INLINE_F603_8902
#endif
#ifndef INLINE_F603_8898
static void inline_F603_8898 (EIF_POINTER arg1, EIF_POINTER arg2)
{
	{
  int rc;
  int fd[2];
  EIF_INTEGER * read_ptr;
  EIF_INTEGER * write_ptr;
  rc = pipe(fd);
  if (rc != 0) {
    eraise(Strerror(errno), EN_SYS);
  }
  read_ptr = (EIF_INTEGER *) arg1;
  write_ptr = (EIF_INTEGER *) arg2;
  *read_ptr = fd[0];
  *write_ptr = fd[1];
}
	;
}
#define INLINE_F603_8898
#endif
#ifndef INLINE_F603_8900
static void inline_F603_8900 (EIF_INTEGER_32 arg1, EIF_BOOLEAN arg2, EIF_BOOLEAN* arg3, EIF_INTEGER_32* arg4, EIF_BOOLEAN* arg5)
{
	{
  pid_t rc;
  int status;
  
  rc = waitpid((pid_t) arg1, &status, (arg2 ? 0 : WNOHANG) | WUNTRACED);
  *(EIF_BOOLEAN *) arg5 = (rc != -1);
  if (rc != -1) {				    
	  if (rc == 0) { /* No process has status to report yet */
	    *(EIF_BOOLEAN *) arg3 = EIF_FALSE;
	  } else { /* Process reported status */
	    *(EIF_BOOLEAN *) arg3 = EIF_TRUE;
	  }
	  *(EIF_INTEGER *) arg4 = (EIF_INTEGER) status;
  }
}
	;
}
#define INLINE_F603_8900
#endif
#ifndef INLINE_F603_8905
static void inline_F603_8905 (EIF_INTEGER_32 arg1)
{
	{
	pid_t pgid = getpgid (arg1);
	tcsetpgrp (1, pgid);
	tcsetpgrp (2, pgid);
}
	;
}
#define INLINE_F603_8905
#endif

#ifdef __cplusplus
}
#endif


#ifdef __cplusplus
extern "C" {
#endif

/* {PROCESS_UNIX_OS}.duplicate_file_descriptor */
void F603_8886 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1, EIF_INTEGER_32 arg2)
{
	GTCX
	
	
	inline_F603_8886 ((EIF_INTEGER_32) arg1, (EIF_INTEGER_32) arg2);
}

/* {PROCESS_UNIX_OS}.close_file_descriptor */
void F603_8887 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	
	
	inline_F603_8887 ((EIF_INTEGER_32) arg1);
}

/* {PROCESS_UNIX_OS}.fork_process */
EIF_INTEGER_32 F603_8889 (EIF_REFERENCE Current)
{
	GTCX
	EIF_INTEGER_32 ti4_1;
	RTLD;
	
	RTLI(1);
	RTLR(0,Current);
	RTLIU(1);
	
	RTGC;
	{
		/* INLINED CODE (PROCESS_UNIX_OS.unix_fork_process) */
		ti4_1 = (EIF_INTEGER_32)  0;
		inline_F603_8901((EIF_INTEGER_32 *) &(ti4_1));
		/* END INLINED CODE */
	}
	RTLE;
	return (EIF_INTEGER_32) ti4_1;
}

/* {PROCESS_UNIX_OS}.new_process_group */
void F603_8890 (EIF_REFERENCE Current)
{
	GTCX
	
	
	inline_F603_8890 ();
}

/* {PROCESS_UNIX_OS}.exec_process */
void F603_8891 (EIF_REFERENCE Current, EIF_REFERENCE arg1, EIF_REFERENCE arg2, EIF_BOOLEAN arg3, EIF_POINTER arg4)
{
	GTCX
	EIF_INTEGER_32 loc1 = (EIF_INTEGER_32) 0;
	EIF_INTEGER_32 loc2 = (EIF_INTEGER_32) 0;
	EIF_INTEGER_32 loc3 = (EIF_INTEGER_32) 0;
	EIF_POINTER loc4 = (EIF_POINTER) 0;
	EIF_REFERENCE loc5 = (EIF_REFERENCE) 0;
	EIF_POINTER tp1;
	EIF_POINTER tp2;
	EIF_POINTER tp3;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	EIF_INTEGER_32 ti4_1;
	EIF_INTEGER_32 ti4_2;
	RTLD;
	
	RTLI(6);
	RTLR(0,arg2);
	RTLR(1,Current);
	RTLR(2,loc5);
	RTLR(3,tr1);
	RTLR(4,tr2);
	RTLR(5,arg1);
	RTLIU(6);
	
	RTGC;
	{
		/* INLINED CODE (ARRAY.count) */
		ti4_1 = (EIF_INTEGER_32)  0;
		(void) RTCW(arg2);
		ti4_1 = *(EIF_INTEGER_32 *)(arg2 + O14422[Dtype(arg2)-1754]);
		ti4_2 = *(EIF_INTEGER_32 *)(arg2 + O14423[Dtype(arg2)-1754]);
		ti4_1 = (EIF_INTEGER_32) (EIF_INTEGER_32) ((EIF_INTEGER_32) (ti4_1 - ti4_2) + ((EIF_INTEGER_32) 1L));
		/* END INLINED CODE */
	}
	loc2 = ti4_1;
	loc3 = *(EIF_INTEGER_32 *)(RTCW(arg2) + O14423[Dtype(arg2)-1754]);
	{
		/* INLINED CODE (PROCESS_UNIX_OS.unix_allocate_arg_memory) */
		ti4_1 = (EIF_INTEGER_32) (loc2 + ((EIF_INTEGER_32) 1L));
		tp1 = (EIF_POINTER)  0;
		inline_F603_8903(ti4_1, (EIF_POINTER *) &(tp1));
		/* END INLINED CODE */
	}
	loc4 = tp1;
	loc5 = RTLNS(eif_new_type(920, 0x00).id, 920, _OBJSIZ_1_0_0_1_0_0_0_0_);
	F921_12996(RTCW(loc5), ((EIF_INTEGER_32) 0L));
	loc1 = (EIF_INTEGER_32) ((EIF_INTEGER_32) 1L);
	for (;;) {
		if ((EIF_BOOLEAN) (loc1 > loc2)) break;
		{
			/* INLINED CODE (ARRAY.item) */
			ti4_1 = (EIF_INTEGER_32) ((EIF_INTEGER_32) (loc3 + loc1) - ((EIF_INTEGER_32) 1L));
			tr1 = (EIF_REFERENCE)  0;
			(void) RTCW(arg2);
			tr2 = *(EIF_REFERENCE *)(arg2);
			tr1 = 
				/* INLINED CODE (SPECIAL.item) */
				*((EIF_REFERENCE *)RTCW(tr2) + ((EIF_INTEGER_32) (ti4_1 - *(EIF_INTEGER_32 *)(arg2 + O14423[Dtype(arg2)-1754]))))
				/* END INLINED CODE */;
			/* END INLINED CODE */
		}
		tr1 = tr1;
		{
			/* INLINED CODE (NATIVE_STRING.set_string) */
			(void) RTCW(loc5);
			ti4_1 = (FUNCTION_CAST(EIF_INTEGER_32, (EIF_REFERENCE)) R17118[Dtype(RTCW(tr1))-2076])(tr1);
			F921_13011(loc5, tr1, ((EIF_INTEGER_32) 1L), ti4_1);
			/* END INLINED CODE */
		}
		;
		{
			/* INLINED CODE (NATIVE_STRING.item) */
			tp1 = (EIF_POINTER)  0;
			(void) RTCW(loc5);
			tr1 = *(EIF_REFERENCE *)(loc5);
			tp1 = *(EIF_POINTER *)(RTCW(tr1)+ _PTROFF_0_1_0_1_0_0_);
			/* END INLINED CODE */
		}
		tp1 = tp1;
		{
			/* INLINED CODE (PROCESS_UNIX_OS.str_dup) */
			tp2 = (EIF_POINTER)  0;
			inline_F603_8897(tp1, (EIF_POINTER *) &(tp2));
			/* END INLINED CODE */
		}
		tp3 = tp2;
		inline_F603_8904(loc4, (EIF_INTEGER_32) (loc1 - ((EIF_INTEGER_32) 1L)), tp3);
		loc1++;
	}
	{
		/* INLINED CODE (ANY.default_pointer) */
		tp1 = (EIF_POINTER)  0;
		/* END INLINED CODE */
	}
	tp2 = tp1;
	inline_F603_8904(loc4, loc2, tp2);
	loc5 = RTLNS(eif_new_type(920, 0x00).id, 920, _OBJSIZ_1_0_0_1_0_0_0_0_);
	F921_12995(RTCW(loc5), arg1);
	{
		/* INLINED CODE (NATIVE_STRING.item) */
		tp1 = (EIF_POINTER)  0;
		(void) RTCW(loc5);
		tr1 = *(EIF_REFERENCE *)(loc5);
		tp1 = *(EIF_POINTER *)(RTCW(tr1)+ _PTROFF_0_1_0_1_0_0_);
		/* END INLINED CODE */
	}
	tp1 = tp1;
	inline_F603_8902(tp1, loc4, arg4, arg3);
	RTLE;
}

/* {PROCESS_UNIX_OS}.unix_fork_process */
EIF_INTEGER_32 F603_8894 (EIF_REFERENCE Current)
{
	GTCX
	EIF_INTEGER_32 Result = ((EIF_INTEGER_32) 0);
	
	
	
	inline_F603_8901((EIF_INTEGER_32 *) &(Result));
	return Result;
}

/* {PROCESS_UNIX_OS}.str_dup */
EIF_POINTER F603_8895 (EIF_REFERENCE Current, EIF_POINTER arg1)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	inline_F603_8897(arg1, (EIF_POINTER *) &(Result));
	return Result;
}

/* {PROCESS_UNIX_OS}.unix_allocate_arg_memory */
EIF_POINTER F603_8896 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	inline_F603_8903(arg1, (EIF_POINTER *) &(Result));
	return Result;
}

/* {PROCESS_UNIX_OS}.c_str_dup */
void F603_8897 (EIF_REFERENCE Current, EIF_POINTER arg1, EIF_POINTER* arg2)
{
	GTCX
	
	
	inline_F603_8897 ((EIF_POINTER) arg1, (EIF_POINTER*) arg2);
}

/* {PROCESS_UNIX_OS}.unix_pipe */
void F603_8898 (EIF_REFERENCE Current, EIF_POINTER arg1, EIF_POINTER arg2)
{
	GTCX
	
	
	inline_F603_8898 ((EIF_POINTER) arg1, (EIF_POINTER) arg2);
}

/* {PROCESS_UNIX_OS}.unix_waitpid */
void F603_8900 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1, EIF_BOOLEAN arg2, EIF_BOOLEAN* arg3, EIF_INTEGER_32* arg4, EIF_BOOLEAN* arg5)
{
	GTCX
	
	
	EIF_ENTER_C;
	inline_F603_8900 ((EIF_INTEGER_32) arg1, (EIF_BOOLEAN) arg2, (EIF_BOOLEAN*) arg3, (EIF_INTEGER_32*) arg4, (EIF_BOOLEAN*) arg5);
	EIF_EXIT_C;
	RTGC;
}

/* {PROCESS_UNIX_OS}.c_unix_fork_process */
void F603_8901 (EIF_REFERENCE Current, EIF_INTEGER_32* arg1)
{
	GTCX
	
	
	inline_F603_8901 ((EIF_INTEGER_32*) arg1);
}

/* {PROCESS_UNIX_OS}.unix_exec_process */
void F603_8902 (EIF_REFERENCE Current, EIF_POINTER arg1, EIF_POINTER arg2, EIF_POINTER arg3, EIF_BOOLEAN arg4)
{
	GTCX
	
	
	inline_F603_8902 ((EIF_POINTER) arg1, (EIF_POINTER) arg2, (EIF_POINTER) arg3, (EIF_BOOLEAN) arg4);
}

/* {PROCESS_UNIX_OS}.c_unix_allocate_arg_memory */
void F603_8903 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1, EIF_POINTER* arg2)
{
	GTCX
	
	
	inline_F603_8903 ((EIF_INTEGER_32) arg1, (EIF_POINTER*) arg2);
}

/* {PROCESS_UNIX_OS}.unix_set_arg_value */
void F603_8904 (EIF_REFERENCE Current, EIF_POINTER arg1, EIF_INTEGER_32 arg2, EIF_POINTER arg3)
{
	GTCX
	
	
	inline_F603_8904 ((EIF_POINTER) arg1, (EIF_INTEGER_32) arg2, (EIF_POINTER) arg3);
}

/* {PROCESS_UNIX_OS}.attach_terminals */
void F603_8905 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	
	
	inline_F603_8905 ((EIF_INTEGER_32) arg1);
}

void EIF_Minit541 (void)
{
	GTCX
}


#ifdef __cplusplus
}
#endif
